package com.yeejoin.amos.api.tool.config;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.SerializationFeature;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.converter.HttpMessageConverter;
import org.springframework.http.converter.json.MappingJackson2HttpMessageConverter;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurationSupport;
import java.util.List;


@Configuration
public class GlobalConfig extends WebMvcConfigurationSupport {

     @Override
     protected void configureMessageConverters(List<HttpMessageConverter<?>> converters){
         super.configureMessageConverters(converters);
         converters.add(mappingJackson2HttpMessageConverter());
     }

     private MappingJackson2HttpMessageConverter mappingJackson2HttpMessageConverter(){
         ObjectMapper objectMapper=new ObjectMapper();
         objectMapper.configure(SerializationFeature.FAIL_ON_EMPTY_BEANS,false);
         //排除返回前端的Null对象
         objectMapper.setSerializationInclusion(JsonInclude.Include.NON_NULL);
         return new MappingJackson2HttpMessageConverter(objectMapper);
     }

}
