package com.yeejoin.amos.api.tool.face.rowmapper;

import com.alibaba.fastjson.JSONObject;
import com.yeejoin.amos.api.tool.face.model.TemplateCategoryModel;
import org.apache.commons.lang.StringUtils;
import org.springframework.jdbc.core.RowMapper;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;


/**
 * ԶRowMapper ݿjsonֶβתΪJSONObject͵
 */
public class AdapterCategoryRowMapper implements RowMapper<TemplateCategoryModel> {
    @Override
    public TemplateCategoryModel mapRow(ResultSet rs, int rowNum) throws SQLException {
        TemplateCategoryModel categoryModel = new TemplateCategoryModel();
        // ﴦJSONֶεת
        categoryModel.setSequenceNbr(Long.valueOf(rs.getString("SEQUENCE_NBR")));
        categoryModel.setCateName(rs.getString("CATEGORY_NAME"));
        categoryModel.setIcon(rs.getString("ICON"));
        categoryModel.setRecUserId(rs.getString("REC_USER_ID"));
        String extras = rs.getString("EXTRAS");
        if (StringUtils.isNotBlank(extras)){
            JSONObject jsonObject = JSONObject.parseObject(extras);
            categoryModel.setTplType(jsonObject.getString("tempType"));
            categoryModel.setDesignerType(jsonObject.getString("designerType"));
        }
        Timestamp timestamp = rs.getTimestamp("REC_DATE");
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String formattedDateTime = dateFormat.format(timestamp);
        try {
            categoryModel.setRecDate(dateFormat.parse(formattedDateTime));
        } catch (ParseException e) {
            throw new RuntimeException(e);
        }
        return categoryModel;
    }
}

