package com.yeejoin.amos.api.tool.face.rowmapper;

import com.yeejoin.amos.api.tool.face.model.ApiInfoModel;
import org.springframework.jdbc.core.RowMapper;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;

public class StudioDataApiRowMapper implements RowMapper<ApiInfoModel> {

    @Override
    public ApiInfoModel mapRow(ResultSet rs, int rowNum) throws SQLException {
        ApiInfoModel apiSourceModel = new ApiInfoModel();
        apiSourceModel.setSequenceNbr(rs.getLong("SEQUENCE_NBR"));
        apiSourceModel.setRecUserId(rs.getString("REC_USER_ID"));
        apiSourceModel.setApiSource(rs.getString("API_SOURCE"));
        apiSourceModel.setApiName(rs.getString("API_NAME"));
        apiSourceModel.setApiPath(rs.getString("API_PATH"));
        apiSourceModel.setHttpMethod(rs.getString("HTTP_METHOD"));
        apiSourceModel.setResType(rs.getString("RES_TYPE"));
        apiSourceModel.setRuleData(rs.getString("RULE_DATA"));
        apiSourceModel.setBodyValue(rs.getString("BODY_VALUE"));
        Timestamp timestamp = rs.getTimestamp("REC_DATE");
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String formattedDateTime = dateFormat.format(timestamp);
        try {
            apiSourceModel.setRecDate(dateFormat.parse(formattedDateTime));
        } catch (ParseException e) {
            throw new RuntimeException(e);
        }
        return apiSourceModel;
    }
}
