package com.yeejoin.amos.api.tool.face.rowmapper;

import com.alibaba.fastjson.JSONObject;
import com.yeejoin.amos.api.tool.face.model.TemplateModel;
import org.springframework.jdbc.core.RowMapper;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;

// ԶRowMapper ݿjsonֶβתΪJSONObject͵
public class StudioTemplateRowMapper implements RowMapper<TemplateModel> {
    @Override
    public TemplateModel mapRow(ResultSet rs, int rowNum) throws SQLException {
        TemplateModel templateModel = new TemplateModel();
        // ﴦJSONֶεת
        templateModel.setSequenceNbr(rs.getLong("SEQUENCE_NBR"));
        templateModel.setDisplayName(rs.getString("DISPLAY_NAME"));
        templateModel.setComKey(rs.getString("COMPONENT_KEY"));
        templateModel.setComName(rs.getString("COMPONENT_NAME"));
        templateModel.setContent(JSONObject.parseObject(rs.getString("CONTENT")));
        templateModel.setCateSeq(rs.getLong("CATEGORY_SEQ"));
        templateModel.setThumb(rs.getString("THUMB"));
        templateModel.setSketch(rs.getString("SKETCH"));
        String isDel = rs.getString("IS_DELETE");
        templateModel.setIsDel(false);
        if ("1".equals(isDel)){
            templateModel.setIsDel(true);
        }
        String openStatus = rs.getString("OPEN_STATUS");
        templateModel.setOpenStatus(false);
        if ("1".equals(openStatus)){
            templateModel.setOpenStatus(true);
        }
        Timestamp timestamp = rs.getTimestamp("REC_DATE");
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String formattedDateTime = dateFormat.format(timestamp);
        try {
            templateModel.setRecDate(dateFormat.parse(formattedDateTime));
        } catch (ParseException e) {
            throw new RuntimeException(e);
        }
        templateModel.setRecUserId(rs.getString("REC_USER_ID"));
        return templateModel;
    }
}

