package com.yeejoin.amos.api.tool.face.rowmapper;

import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.yeejoin.amos.api.tool.face.model.TemplateCategoryModel;
import org.apache.commons.lang.StringUtils;
import org.springframework.jdbc.core.RowMapper;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.text.SimpleDateFormat;

public class TemplateCategoryRowMapper implements RowMapper<TemplateCategoryModel> {
    @Override
    public TemplateCategoryModel mapRow(ResultSet rs, int i) throws SQLException {
        TemplateCategoryModel templateCategoryModel = new TemplateCategoryModel();
        // 在这里处理JSON字段的转换
        templateCategoryModel.setSequenceNbr(Long.valueOf(rs.getString("SEQUENCE_NBR")));
        templateCategoryModel.setCateName(rs.getString("CATEGORY_NAME"));
        templateCategoryModel.setIcon(rs.getString("ICON"));
        templateCategoryModel.setRecUserId(rs.getString("REC_USER_ID"));
        String extras = rs.getString("EXTRAS");
        ObjectMapper objectMapper = new ObjectMapper();
        try {
            JsonNode jsonNode = objectMapper.readTree(extras);
            if (StringUtils.isNotBlank(extras)){
                String value1 = jsonNode.get("tempType").asText();
                String value2 = jsonNode.get("designerType").asText();
                templateCategoryModel.setTplType(value1);
                templateCategoryModel.setDesignerType(value2);
            }
            Timestamp timestamp1 = rs.getTimestamp("REC_DATE");
            SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String formattedDateTime1 = dateFormat.format(timestamp1);
            templateCategoryModel.setRecDate(dateFormat.parse(formattedDateTime1));
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
        return templateCategoryModel;
    }
}
